# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib
%bcond_with bootstrap

%define repodir %{_javadir}/repository.jboss.com/apache-log4j/1.2.15-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Name:           log4j
Version:        1.2.15
Release:        1%{?dist}
Epoch:          0
Summary:        Java logging package
License:        ASL 2.0
Group:          System/Logging
URL:            http://logging.apache.org/log4j/
Source0:        http://www.apache.org/dist/logging/log4j/1.2.15/apache-log4j-1.2.15.tar.gz
# Converted from src/java/org/apache/log4j/lf5/viewer/images/lf5_small_icon.gif
Source1:        %{name}-logfactor5.png
Source2:        %{name}-logfactor5.sh
Source3:        %{name}-logfactor5.desktop
# Converted from docs/images/logo.jpg
Source4:        %{name}-chainsaw.png
Source5:        %{name}-chainsaw.sh
Source6:        %{name}-chainsaw.desktop
Source7:        %{name}.catalog
Source8:        log4j-component-info.xml
Source9:        http://repo1.maven.org/maven2/log4j/log4j/1.2.15/log4j-1.2.15.pom
Patch0:         %{name}-logfactor5-userdir.patch
Patch1:         %{name}-javadoc-xlink.patch
Patch2:         %{name}-mx4j-tools.patch
Patch3:         %{name}-jmx-Agent.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils >= 0:1.7.3
%if %without bootstrap
Requires:       jaf_1_0_2_api
Requires:       jaxp_parser_impl
Requires:       javamail_1_3_1_api
Requires:       jms_1_1_api
Requires:       mx4j
%endif
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant
%if %without bootstrap
BuildRequires:  jaf_1_0_2_api
BuildRequires:  javamail_1_3_1_api
BuildRequires:  jms_1_1_api
BuildRequires:  mx4j
%endif
BuildRequires:  java-javadoc
BuildRequires:  jaxp_parser_impl
BuildRequires:  jndi
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Log4j is a tool to help the programmer output log statements to a
variety of output targets.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package manual
Summary:        Manual for %{name}
Group:          System/Logging

%description manual
Documentation for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n apache-%{name}-%{version}
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%{__perl} -pi -e 's/\r$//g' LICENSE NOTICE

for file in contribs/JimMoore/mail-2001-03-12T1454 contribs/JimMoore/mail-2001-03-13T0646; do
    %{__mv} ${file} ${file}.orig
    %{_bindir}/iconv -f iso-8859-1 -t utf8 -o ${file} ${file}.orig
    %{__rm} ${file}.orig
done

# remove all the stuff we'll build ourselves
find . -name "*.jar" -o -name "*.class" | xargs %{__rm}
#%__rm -r docs/api

# fix perl location
%__perl -p -i -e 's|/opt/perl5/bin/perl|%{__perl}|' \
contribs/KitchingSimon/udpserver.pl

%build
# javac.source=1.1 doesn't work with Sun's 1.4.2_09/1.5.0_05
# Provide -Djmx-present="true" option to build Patch02 to enable HtmlAdaptor
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} \
        -Djavamail.jar=$(build-classpath javamail_1_3_1_api) \
        -Dactivation.jar=$(build-classpath jaf_1_0_2_api) \
        -Djaxp.jaxp.jar.jar=$(build-classpath jaxp_parser_impl) \
        -Djms.jar=$(build-classpath jms_1_1_api) \
        -Djmx.jar=$(build-classpath mx4j/mx4j) \
        -Djmx-extra.jar=$(build-classpath mx4j/mx4j-tools) \
        -Djndi.jar=$(build-classpath jndi) \
        -Djavac.source=1.2 \
        -Djdk.javadoc=%{_javadocdir}/java \
        jar javadoc

%install
%__rm -rf %{buildroot}

# jars
%__mkdir_p %{buildroot}%{_javadir}
%__cp -a dist/lib/%{name}-%{version}.jar %{buildroot}%{_javadir}
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
%__mkdir_p %{buildroot}%{_datadir}/maven2/poms
%__cp -a %{SOURCE9} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}

# javadoc
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}
%__cp -a docs/api/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && %__ln_s %{name}-%{version} %{name})
# FIXME: (dwalluck) This breaks -bi --short-circuit
%__rm -rf docs/api
ln -s %{_javadocdir}/log4j docs/api

# scripts
%__mkdir_p %{buildroot}%{_bindir}
%__install -p -m 755 %{SOURCE2} %{buildroot}%{_bindir}/logfactor5
%__install -p -m 755 %{SOURCE5} %{buildroot}%{_bindir}/chainsaw

# freedesktop.org menu entries and icons
%__mkdir_p %{buildroot}%{_datadir}/{applications,pixmaps}
%__cp -a %{SOURCE1} \
  %{buildroot}%{_datadir}/pixmaps/logfactor5.png
%__cp -a %{SOURCE3} \
  %{buildroot}%{_datadir}/applications/jpackage-logfactor5.desktop
%__cp -a %{SOURCE4} \
  %{buildroot}%{_datadir}/pixmaps/chainsaw.png
%__cp -a %{SOURCE6} \
  %{buildroot}%{_datadir}/applications/jpackage-chainsaw.desktop

# DTD and the SGML catalog (XML catalog handled in scriptlets)
%__mkdir_p %{buildroot}%{_datadir}/sgml/%{name}
%__cp -a src/main/resources/org/apache/log4j/xml/log4j.dtd \
  %{buildroot}%{_datadir}/sgml/%{name}
%__cp -a %{SOURCE7} \
  %{buildroot}%{_datadir}/sgml/%{name}/catalog

%__mkdir_p %{buildroot}%{_sysconfdir}/sgml
/bin/touch %{buildroot}%{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %{with_repolib}
%__install -d -m 755 $RPM_BUILD_ROOT%{repodir}
%__install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
%__install -p -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %__sed 's|\.|_|g'`
%__sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
%__sed -i "s/@VERSION@/%{version}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
%__install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
%__install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
%__install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
%__install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
%__cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/log4j.jar
%endif

%clean
%__rm -rf %{buildroot}

%post
%update_maven_depmap
/bin/touch %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat 2>/dev/null
# Note that we're using versioned catalog, so this is always ok.
if [ -x %{_bindir}/install-catalog -a -d %{_sysconfdir}/sgml ]; then
  %{_bindir}/install-catalog --add \
    %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat \
    %{_datadir}/sgml/%{name}/catalog > /dev/null 2>&1 || :
fi
if [ -x %{_bindir}/xmlcatalog -a -w %{_sysconfdir}/xml/catalog ]; then
  %{_bindir}/xmlcatalog --noout --add system log4j.dtd \
    file://%{_datadir}/sgml/%{name}/log4j.dtd %{_sysconfdir}/xml/catalog \
    > /dev/null 2>&1 || :
fi

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
if [ $1 -eq 0 ]; then
  if [ -x %{_bindir}/xmlcatalog -a -w %{_sysconfdir}/xml/catalog ]; then
    %{_bindir}/xmlcatalog --noout --del log4j.dtd \
      %{_sysconfdir}/xml/catalog > /dev/null 2>&1 || :
  fi
fi

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
# Note that we're using versioned catalog, so this is always ok.
if [ -x %{_bindir}/install-catalog -a -d %{_sysconfdir}/sgml ]; then
  %{_bindir}/install-catalog --remove \
    %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat \
    %{_datadir}/sgml/%{name}/catalog > /dev/null 2>&1 || :
fi

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE NOTICE
%attr(0755,root,root) %{_bindir}/chainsaw
%attr(0755,root,root) %{_bindir}/logfactor5
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%{_datadir}/applications/*chainsaw.desktop
%{_datadir}/applications/*logfactor5.desktop
%{_datadir}/pixmaps/chainsaw.png
%{_datadir}/pixmaps/logfactor5.png
%{_datadir}/sgml/%{name}
%ghost %{_sysconfdir}/sgml/%{name}-%{version}-%{release}.cat
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.so
%endif

%files manual
%defattr(0644,root,root,0755)
# FIXME: (dwalluck) Manuals are usually installed at an absolute location inside %%{_docdir}
%doc docs/* contribs

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Thu Sep 03 2009 Ralph Apel <r.apel at r-apel.de> 0:1.2.15-1
- 1.2.15

* Fri Feb 20 2009 David Walluck <dwalluck@redhat.com> 0:1.2.14-15
- fix JMX support
- require the API providers that are used for build
- fix file-not-utf8

* Fri Feb 06 2009 Ralph Apel <r.apel at r-apel.de> 0:1.2.14-14
- Add pom and depmap frag
- Omit xml-commons-apis, jaxp_parser_impl Requires
- (B)R, post, postun jpackage-utils >= 0:1.7.2
- BR java-devel >= 0:1.5.0, R java >= 0:1.5.0

* Fri Dec 05 2008 David Walluck <dwalluck@redhat.com> 0:1.2.14-13
- fix repolib file ownership
- fix repolib file permissions
- fix component-info.xml
- fix installed catalog
- use more explicit file list
- fix GCJ support
- fix javadocs
- fix some API jars

* Thu May 29 2008 David Walluck <dwalluck@redhat.com> 0:1.2.14-4.jpp5
- add mx4j patch from 0:1.2.14-3jpp, but not applying (creates Sun dependency)
- fix License
- remove javadoc scriptlets
- own %%{_libdir}/gcj/%%{name}
- fix file permissions
- fix macros in %%changelog

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2.14-1jpp.ep1.1
- New repolib location

* Thu Feb 22 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.14-1jpp.el4ep1.3
- Fix the component-info.xml file to use the right atribute in import

* Sun Feb 18 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.14-1jpp.el4ep1.2
- Add repolib support

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2.14-1jpp.el4ep1.1
- Merge for upgrade

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.2.14-1jpp
- Upgrade

* Mon Feb 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.13-4jpp
- Add bootstrap option to build core

* Tue Aug 08 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.13-3jpp
- Add requires-post/postun sections for javadoc subpackage.

* Fri Jul 21 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.2.13-2jpp
- Add conditional native compilation for GCJ.

* Tue Apr 04 2006 Fernando Nasser <fnasser@redhat.com> - 0.1.2.13-1jpp_1rh
- Merge for 1.2.13 upgrade

* Mon Mar 03 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2.13-1jpp
- 1.2.13.
- Replace non-free dependencies

* Thu Nov 17 2005 Fernando Nasser <fnasser@redhat.com> - 0.1.2.8-7jpp_3rh
- Merge for 1.2.12 upgrade
- Use generic javamail alternative
- Explicitly require mx4j

* Thu Oct 13 2005 Ville Skyttä <scop at jpackage.org> - 0:1.2.12-1jpp
- 1.2.12.

* Sun Aug 21 2005 Ville Skyttä <scop at jpackage.org> - 0:1.2.11-1jpp
- 1.2.11.

* Tue Apr 26 2005 Ville Skyttä <scop at jpackage.org> - 0:1.2.9-1jpp
- 1.2.9.
- Fix URLs.
- Crosslink with local JDK javadocs.

* Tue Feb 22 2005 David Walluck <david@jpackage.org> 0:1.2.8-9jpp
- own non-versioned javadoc symlink
- fix perl location in contribs script

* Sat Aug 21 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.2.8-8jpp
- Rebuild wit Ant 1.6.2

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> - 0.1.2.8-7jpp_1rh
- RH vacuuming

* Sun Aug 31 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2.8-7jpp
- Add scripts and freedesktop.org menu entries for LogFactor5 and Chainsaw.
- Include log4j.dtd and install SGML/XML catalogs.
- Require jpackage-utils, jaxp_parser_impl.
- Crosslink with local xml-commons-apis javadocs.
- Don't BuildRequire JUnit, the test suite is not included :(
- Fix Group.

* Sun May 11 2003 David Walluck <david@anti-microsoft.org> 0:1.2.8-6jpp
- add jpackage-utils requirement
- add epochs to all versioned requirements
- use jmx explicitly for now until mx4j works

* Thu Mar 21 2003 Nicolas Mailhot <Nicolas.Mailhot (at) laPoste.net> 1.2.8-3jpp
- For jpackage-utils 1.5

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.2.8-2jpp
- fix ASF license and add packager tag

* Thu Feb 20 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.2.8-1jpp
- log4j 1.2.8

* Thu Oct 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.7-1jpp
- log4j 1.2.7

* Fri Aug 23 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.6-1jpp
- log4j 1.2.6

* Wed Jul 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.5-1jpp
- log4j 1.2.5

* Tue Jul 02 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.2.4-2jpp
- section macro

* Thu Jun 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.2.4-1jpp
- log4j 1.2.4

* Thu Jan 17 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1.3-8jpp
- versioned dir for javadoc
- drop j2ee package
- no dependencies for manual and javadoc packages
- adaptation for new jaf and javamail packages

* Sat Dec 8 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1.3-7jpp
- drop j2ee patch

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1.3-6jpp
- javadoc into javadoc package
- drop %%{name}-core.jar

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 1.1.3-5jpp
- new jpp extension
- fixed compilation (added activation in the classpath)
- BuildRequires: jaf

* Tue Nov 20 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1.3-4jpp
- non-free extension classes back in original archive
- removed packager tag

* Tue Oct 9 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1.3-3jpp
- first unified release
- non-free extension as additional package
- s/jPackage/JPackage

* Tue Sep 04 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1.3-2mdk
- rebuild with javamail to provide SMTP appender
- add CVS references

* Sun Aug 26 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1.3-1mdk
- 1.1.3
- used new source packaging policy
- vendor tag
- packager tag
- s/Copyright/License/
- truncated description to 72 columns in spec
- spec cleanup
- used versioned jar

* Sat Feb 17 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.0.4-3mdk
- spec cleanup
- changelog correction
- build with junit

* Sun Feb 04 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.0.4-2mdk
- merged with Henri Gomez <hgomez@users.sourceforge.net> specs:
-  changed name to log4j
-  changed javadir to /usr/share/java
-  dropped jdk & jre requirement
-  added jikes support
-  changed description
- added xerces requirement
- more macros

* Sun Jan 14 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.0.4-1mdk
- first Mandrake release
